package dev.fyloz.colorrecipesexplorer.service.files

import org.springframework.core.io.Resource
import org.springframework.core.io.ResourceLoader
import org.springframework.stereotype.Service

@Service
class ResourceFileService(
    private val resourceLoader: ResourceLoader
) : FileService {
    override fun exists(path: String) =
        read(path).exists()

    override fun read(path: String): Resource =
        path.fullPath().resource.also {
            if (!it.exists()) {
                throw FileNotFoundException(path)
            }
        }

    override fun String.fullPath() =
        FilePath("classpath:${this}")

    private val FilePath.resource: Resource
        get() = resourceLoader.getResource(this.path)
}
